%global saversion 3.004006

Summary: Spam filter for email which can be invoked from mail delivery agents
Name: spamassassin
Version: 3.4.6
Release: 4%{?dist}
License: ASL 2.0
URL: https://spamassassin.apache.org/
Source0: https://www.apache.org/dist/%{name}/source/Mail-SpamAssassin-%{version}.tar.bz2
Source1: https://www.apache.org/dist/%{name}/source/Mail-SpamAssassin-rules-%{version}.r1888502.tgz
Source2: spamassassin-default.rc
Source3: spamassassin-spamc.rc
Source4: spamassassin.sysconfig
Source5: sa-update.logrotate
Source6: sa-update.cronscript
Source7: sa-update.force-sysconfig
Source8: spamassassin-helper.sh
Source9: spamassassin-official.conf
Source10: spamassassin.service
Source11: sa-update.service
Source12: sa-update.timer

Patch3000: spamassassin-3.4.1-add-logfile-homedir-options.patch

BuildRequires: make gcc perl-interpreter >= 5.8.0
BuildRequires: perl(IO::Socket::SSL)  perl(IO::Socket::IP) perl-devel perl(Mail::DKIM)
BuildRequires: perl(Archive::Tar)
BuildRequires: perl(Digest::SHA1) perl(Test::More) systemd-units perl-HTML-Parser >= 3.43
BuildRequires: openssl-devel perl(DB_File) perl(Mail::SPF) perl(Net::CIDR::Lite) perl(LWP::UserAgent)
BuildRequires: perl-generators perl(Net::DNS) perl(Time::HiRes) perl(HTML::Parser) perl(NetAddr::IP)


Requires: perl(Socket) perl(Data::Dumper) perl(Digest::MD5) perl(Errno) perl(Exporter) perl(List::Util)
Requires: perl(IO::Socket::SSL) perl(IO::Socket::IP) perl(Mail::DKIM) perl(Digest::SHA)
Requires: perl(XSLoader) perl(ExtUtils::MakeMaker) perl-HTML-Parser >= 3.43 perl(Archive::Tar)
Requires: perl(Mail::SPF) perl(Net::CIDR::Lite) perl(Encode::Detect) perl(BSD::Resource) procmail
Requires: perl(HTTP::Date) perl(LWP::UserAgent) perl(Net::DNS) perl(Time::HiRes) perl(DB_File)
Requires: perl-libs
Requires(post): diffutils
Requires(post): systemd-units
Requires(post): systemd-sysv
Requires(preun): systemd-units
Requires(postun): systemd-units

%description
SpamAssassin provides you with a way to reduce if not completely eliminate
Unsolicited Commercial Email (SPAM) from your incoming email.  It can
be invoked by a MDA such as sendmail or postfix, or can be called from
a procmail script, .forward file, etc.  It uses a genetic-algorithm
evolved scoring system to identify messages which look spammy, then
adds headers to the message so they can be filtered by the user's mail
reading software.  This distribution includes the spamd/spamc components
which create a server that considerably speeds processing of mail.

To enable spamassassin, if you are receiving mail locally, simply add
this line to your ~/.procmailrc:
INCLUDERC=/etc/mail/spamassassin/spamassassin-default.rc

To filter spam for all users, add that line to /etc/procmailrc
(creating if necessary).

%prep
%autosetup -p1 -n Mail-SpamAssassin-%{version}


%build
%{__perl} Makefile.PL DESTDIR=%{buildroot}/ SYSCONFDIR=%{_sysconfdir} INSTALLDIRS=vendor ENABLE_SSL="yes" NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build OPTIMIZE="$RPM_OPT_FLAGS"

%install
%make_install PREFIX=%buildroot/%{prefix} \
        INSTALLMAN1DIR=%buildroot/%{_mandir}/man1 \
        INSTALLMAN3DIR=%buildroot/%{_mandir}/man3 \
        LOCAL_RULES_DIR=%{buildroot}/etc/mail/spamassassin
chmod 755 %buildroot/%{_bindir}/*

mkdir -p %{buildroot}%{_sysconfdir}/mail/spamassassin
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
install -m0644 %{SOURCE2} %buildroot/etc/mail/spamassassin
install -m0644 %{SOURCE3} %buildroot/etc/mail/spamassassin
install -m0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/spamassassin
install -m0644 %{SOURCE5} %buildroot/etc/logrotate.d/sa-update
install -m0744 %{SOURCE6} %buildroot%{_datadir}/spamassassin/sa-update.cron
install -m0644 %{SOURCE7} %buildroot%{_sysconfdir}/sysconfig/sa-update
install -m0755 %{SOURCE8} %buildroot/etc/mail/spamassassin
mkdir -p %buildroot%{_unitdir}
install -m0644 %{SOURCE10} %buildroot%{_unitdir}/spamassassin.service
install -m0644 %{SOURCE11} %buildroot%{_unitdir}/sa-update.service
install -m0644 %{SOURCE12} %buildroot%{_unitdir}/sa-update.timer

[ -x /usr/lib/rpm/brp-compress ] && /usr/lib/rpm/brp-compress

find %{buildroot} -name perllocal.pod -exec rm -v {} \;
find %{buildroot} -type d -depth -exec rmdir {} 2>/dev/null ';'

cd %{buildroot}%{_datadir}/spamassassin/
tar xfvz %{SOURCE1}
sed -i -e 's|\@\@VERSION\@\@|%{saversion}|' *.cf
cd -

find %{buildroot}/usr -type f -print |
        sed "s@^%{buildroot}@@g" |
        grep -v perllocal.pod |
        grep -v "\.packlist" > %{name}-%{version}-filelist

find %{buildroot}%{perl_vendorlib}/* -type d -print |
        sed "s@^%{buildroot}@%dir @g" >> %{name}-%{version}-filelist

mkdir -p %{buildroot}%{_localstatedir}/lib/spamassassin

mkdir   -m0700 %{buildroot}%{_sysconfdir}/mail/spamassassin/sa-update-keys/
mkdir   -m0755 %{buildroot}%{_sysconfdir}/mail/spamassassin/channel.d/
install -m0644 %{SOURCE9} %{buildroot}%{_sysconfdir}/mail/spamassassin/channel.d/

%files -f %{name}-%{version}-filelist
%license LICENSE
%doc NOTICE CREDITS Changes README TRADEMARK UPGRADE
%doc USAGE sample-nonspam.txt sample-spam.txt 
%dir %{_sysconfdir}/mail
%config(noreplace) %{_sysconfdir}/mail/spamassassin
%config(noreplace) %{_sysconfdir}/sysconfig/spamassassin
%config(noreplace) %{_sysconfdir}/sysconfig/sa-update
%dir %{_datadir}/spamassassin
%dir %{_localstatedir}/lib/spamassassin
%config(noreplace) %{_sysconfdir}/logrotate.d/sa-update
%{_unitdir}/spamassassin.service
%{_unitdir}/sa-update.service
%{_unitdir}/sa-update.timer

%post
%systemd_post spamassassin.service
%systemd_post sa-update.timer

TMPFILE=$(/bin/mktemp /etc/sysconfig/spamassassin.XXXXXX) || exit 1
cp /etc/sysconfig/spamassassin $TMPFILE
perl -p -i -e 's/(["\s]-\w+)a/$1/ ; s/(["\s]-)a(\w+)/$1$2/ ; s/(["\s])-a\b/$1/' $TMPFILE
perl -p -i -e 's/ --auto-whitelist//' $TMPFILE
cmp /etc/sysconfig/spamassassin $TMPFILE || cp $TMPFILE /etc/sysconfig/spamassassin
rm $TMPFILE

if [ -f /etc/spamassassin.cf ]; then
        mv /etc/spamassassin.cf /etc/mail/spamassassin/migrated.cf
fi
if [ -f /etc/mail/spamassassin.cf ]; then
        mv /etc/mail/spamassassin.cf /etc/mail/spamassassin/migrated.cf
fi

%postun
%systemd_postun spamassassin.service
%systemd_postun sa-update.timer

%preun
%systemd_preun spamassassin.service
%systemd_preun sa-update.timer

%changelog
* Wed Apr 24 2024 wynnfeng <wynnfeng@tencent.com> - 3.4.6-4
- [Type] bugfix
- [DESC] fix installation mistake in spec

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.6-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.6-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Mar 21 2023 cunshunxia <cunshunxia@tencent.com> - 3.4.6-1
- initial build
